We need <sys/time.h> for gettimeofday(), not <time.h>.
[privoxy.git] / privoxy-generic.init
1 #!/bin/sh 
2
3 #  ********************************************************************
4
5 #  File        :  $Source: /cvsroot/ijbswa/current/privoxy-generic.init,v $
6
7 #  Purpose     :  This shell script takes care of starting and stopping
8 #                 privoxy.
9
10 #  Copyright   :  Written by and Copyright (C) 2001,2002 the SourceForge
11 #                 Privoxy team. http://www.privoxy.org/
12
13 #                 Based on the Internet Junkbuster originally written
14 #                 by and Copyright (C) 1997 Anonymous Coders and
15 #                 Junkbusters Corporation.  http://www.junkbusters.com
16
17 #                 This program is free software; you can redistribute it
18 #                 and/or modify it under the terms of the GNU General
19 #                 Public License as published by the Free Software
20 #                 Foundation; either version 2 of the License, or (at
21 #                 your option) any later version.
22
23 #                 This program is distributed in the hope that it will
24 #                 be useful, but WITHOUT ANY WARRANTY; without even the
25 #                 implied warranty of MERCHANTABILITY or FITNESS FOR A
26 #                 PARTICULAR PURPOSE.  See the GNU General Public
27 #                 License for more details.
28
29 #                 The GNU General Public License should be included with
30 #                 this file.  If not, you can view it at
31 #                 http://www.gnu.org/copyleft/gpl.html
32 #                 or write to the Free Software Foundation, Inc., 59
33 #                 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
34 #
35 # Developer's NOTE: This script should be tested against a true /bin/sh, which
36 # has notable differences from bash. By design, this script does not try to do
37 # too much, so as to be as cross-platform as possible.
38 #
39
40 #  Revisions   :
41 #     $Log: privoxy-generic.init,v $
42 #     Revision 1.6  2006/07/18 14:48:47  david__schmidt
43 #     Reorganizing the repository: swapping out what was HEAD (the old 3.1 branch)
44 #     with what was really the latest development (the v_3_0_branch branch)
45 #
46 #     Revision 1.5.2.1  2002/10/17 17:04:22  hal9
47 #     Add from main trunk. Will be needed for make install.
48 #
49 #     Revision 1.5  2002/10/17 17:01:29  hal9
50 #     Set paths to match the defaults for a root install. Force remove PIDFILE on
51 #     stop.
52 #
53 #     Revision 1.4  2002/09/11 01:15:02  hal9
54 #     Fix typo in variable. Now tested on Solaris and Linux, with defaults.
55 #
56 #     Revision 1.3  2002/09/11 01:09:14  hal9
57 #     Better handling of pidfile, and process owner.
58 #
59 #     Revision 1.2  2002/09/08 20:27:58  hal9
60 #     -Rewrote script config section.
61 #     -Added comments to script.
62 #     -Tried to add logic to use a --user privoxy, if available.
63 #     -Minor script changes due to 'echo -n' does not work on a true
64 #      /bin/sh system.
65 #
66 #     Revision 1.1  2002/09/06 00:20:26  hal9
67 #     Creating a generic init script, meant to be used on platforms where don't have
68 #     a custom init script.
69 #
70 #     Revision 1.0  2002/09/05 17:14:32  hal9
71 #
72 #######################################################################
73
74 # Is this needed by Solaris?
75 #ident  "@(#)privoxy  1.0     02/09/05"
76
77 # NOTE: This script may require editing to ensure proper location of 
78 # config file, and the privoxy executable. Care should be taken to ensure 
79 # logfile is writable by $P_USER (logfile is defined in config), and that 
80 # there is suitable write access for $P_PIDFILE.
81
82 PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin/:/usr/bin:/sbin:/bin
83 P_NAME=Privoxy
84 # Path to executable.
85 P_DAEMON=privoxy
86 # Full path to location of Privoxy config file. 
87 P_CONF_FILE=/usr/local/etc/privoxy/config
88 # Full path to PID file location. Location must be writable by 
89 # whoever runs this script and by Privoxy itself.
90 P_PIDFILE=/var/run/privoxy.pid
91 # If uncommented, this script will try to run as USER=privoxy, which
92 # may require special handling of config, *.action, trust, logfile, 
93 # jarfile, and pidfile.
94 P_USER=privoxy
95
96 # If a privoxy user is specified, lets try that. /bin/sh does not seem to 
97 # know about $UID.
98 if [ 0 = `id -u` ]; then
99   if [ -n "$P_USER" ]; then
100     id $P_USER 2>/dev/null >/dev/null
101     if [ $? -eq 0 ]; then
102       P_USER_SETTINGS="--user $P_USER"
103     else
104       echo "User $P_USER doesn't exist, exiting."
105       exit 1
106     fi 
107   else
108     # The user has sufficient rights, but $P_USER isn't set
109     echo "Running Privoxy as root is not recommended!" 
110     P_USER_SETTINGS=""
111   fi
112 else
113   # The user has insufficient rights to run Privoxy as $P_USER
114   # and may not be able to write or delete the PID file.
115   echo "You aren't root, expect trouble!"
116   P_USER_SETTINGS=""
117 fi
118
119 if [ ! -f $P_CONF_FILE ]; then
120   echo "Can't find $P_CONF_FILE, exiting."
121   exit 1
122 fi
123
124 case "$1" in
125  
126  start)
127      if [ -f $P_PIDFILE ]; then
128        if kill -0 `cat $P_PIDFILE`; then
129          echo "Error: $P_NAME is already running, exiting."
130          exit 1
131        else
132          rm -f $P_PIDFILE
133        fi
134      fi
135
136         $P_DAEMON --pidfile $P_PIDFILE $P_USER_SETTINGS $P_CONF_FILE 2>/dev/null
137      
138      if [ $? -eq 0 ]; then
139        echo "Starting $P_NAME, OK." 
140      else
141        echo "Starting $P_NAME, Failed."
142        rm -f $P_PIDFILE
143      fi
144      ;;
145  
146  restart)
147      $0 stop
148      $0 start
149      ;;
150  
151  stop)
152      test ! -f $P_PIDFILE && echo "No $P_PIDFILE file found, exiting." && exit 1
153      kill `cat $P_PIDFILE` && rm -f $P_PIDFILE && \
154      echo "Stopping $P_NAME, OK." || echo "Stopping $P_NAME, failed."
155      ;;
156  
157  *)
158      echo "Usage: $0 {start|stop|restart}"
159      exit 1
160      ;;
161
162 esac
163
164 exit 0